/*
    Copyright 2004,2005,2006,2007,2008,2009 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>



#define VER     "0.1a"
#define BUFFSZ  256



void bpxor(unsigned char *buff, unsigned char size);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE            *fd;
    unsigned char   buff[BUFFSZ + 1],
                    b1,
                    i;

    setbuf(stdout, NULL);

    fputs("\n"
        "Bullet Proof FTP bpftp.dat file decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\n"
            "Usage: %s <bpftp.data>\n"
            "\n", argv[0]);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    fd = fopen(argv[1], "rb");
    if(!fd) std_err();

    do {                    // seeking starting of data
        if(fread(&b1, 1, 1, fd) != 1) break;
        if(fread(buff, 1, b1, fd) != b1) break;
    } while(b1 != 1);

    while(!feof(fd)) {      // feof() useful here
        fputs("------------------\n", stdout);
        for(i = 0; i < 32; i++) {
            if(fread(&b1, 1, 1, fd) != 1) break;
            if(!b1) continue;
            if(fread(buff, 1, b1, fd) != b1) break;

            bpxor(buff, b1);
            switch(i) {
                case 3:  fputs("Site name:        ", stdout); break;
                case 4:  fputs("Site Address:     ", stdout); break;
                case 5:  fputs("Login:            ", stdout); break;
                case 6:  fputs("Local directory:  ", stdout); break;
                case 7:  fputs("Remote directory: ", stdout); break;
                case 8:  fputs("Port:             ", stdout); break;
                case 9:  fputs("Password:         ", stdout); break;
                default: fputs("Unknown:          ", stdout); break;
            }
            printf("%s\n", buff);
        }
    }

    fclose(fd);
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void bpxor(unsigned char *buff, unsigned char size) {
    unsigned int    tmp;
    int     i;

    tmp = size;
    for(i = 0; i < size; i++) {
        tmp = (tmp * 0x08088405) + 1;
        buff[i] ^= (tmp >> 24);
    }
    buff[i] = 0;
}



void std_err(void) {
    perror("\nError");
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}


